#include <default.c>
#include <litec.h>
#include <acknex.h>
#include "spritesys.c"

#define idle 1
#define walk 2
//#define hit 3

#define wright 4
#define wleft 5

sprite* player1;
sprite* player2;
sprite* terrain;
sprite* pgrenade;
sprite* explode;


SOUND* happy_land="happyland.ogg";
SOUND* water="water.ogg";
SOUND* wind="wind.ogg";
SOUND* hawk="hawk.ogg";
SOUND* bang="bang1.wav";
SOUND* ouch="ouch.wav";

var music_handle;
var water_handle;
var hawk_handle;
var wind_handle;

int player_jump=0;
int player_dir=wright;
int player_anim_mode=idle;
anim_seq* player1anim;

int player_jump2=0;
int player_dir2=wleft;
int player_anim_mode2=idle;
anim_seq* player2anim;

BMAP* idle_sheet="idle.png";
BMAP* idle_sheetl="idlel.png";
BMAP* walk_sheet="walk.png";
BMAP* walk_sheetl="walkl.png";
//BMAP* hit_sheet="hit.png";

BMAP* idle_sheet2="idle.png";
BMAP* idle_sheetl2="idlel.png";
BMAP* walk_sheet2="walk.png";
BMAP* walk_sheetl2="walkl.png";
//BMAP* hit_sheet2="hit.png";

BMAP* grenade="grenade.png";
BMAP* explodemap="explode.png";
BMAP* explodexormap="explodexor.png";
BMAP* explodexormap1="explodexor1.png";
BMAP* explodexormap2="explodexor2.png";

sprite* explodexor;

var pi=3.14159265;

var player1_health=100;
var player2_health=100;

VECTOR acceleration;
VECTOR velocity;

var throwpower1=5;
var throwpower2=5;

int wait_grenade_p1=0;
int wait_grenade_p2=0;

var player1_time_left=60;
var player2_time_left=0;

int player1_active=1;
int player2_active=0;

void check_players(sprite* psprite,VECTOR *hitpos)
{
	sprite_move(explode,vector(hitpos.x-bmap_width(explodemap)/2,hitpos.y-bmap_height(explodemap)/2,0));
	remove_pixels_with(explode,terrain);
	
	VECTOR gpos;
	VECTOR p1pos;
	VECTOR p2pos;
	vec_set(gpos,vector(pgrenade.panel.pos_x,pgrenade.panel.pos_y,0));
	vec_set(p1pos,vector(player1.panel.pos_x,player1.panel.pos_y,0));
	vec_set(p2pos,vector(player2.panel.pos_x,player2.panel.pos_y,0));


	var dist=vec_dist(gpos,p1pos);
	if(dist<50)
	{
		player1_health-=20;
		snd_play(ouch,100,0);
	}
	var dist1=vec_dist(gpos,p2pos);
	if(dist1<50)
	{
		player2_health-=20;
		snd_play(ouch,100,0);
	}

	if(player1_health<1)
	{
		PANEL* lost = pan_create(NULL,0);
		FONT* my_font = font_create("Arial#100");
		pan_setstring(lost,0,screen_size.x/2,screen_size.y/2,my_font,str_create("player1 loses!!"));
		layer_sort(lost,101);
		set(lost,SHOW);
		wait(-4);
		sys_exit("try again!");
	}
	
	if(player2_health<1)
	{
		PANEL* lost = pan_create(NULL,0);
		FONT* my_font = font_create("Arial#100");
		pan_setstring(lost,0,screen_size.x/2,screen_size.y/2,my_font,str_create("player2 loses!!"));
		layer_sort(lost,101);
		set(lost,SHOW);
		wait(-4);
		sys_exit("try again!");
	}
	
	
	if(psprite==player1 )
	{
		player1_time_left=0;
	}
	if(psprite==player2 ) 
	{
		player2_time_left=0;
	}

}

void rotate_gr()
{
	pgrenade.panel.angle+=15*time_step;
}

void launch_gr(sprite* psprite,VECTOR *pos,var angle,var speed)
{
   pgrenade=sprite_create(grenade,vector(bmap_width(grenade),bmap_height(grenade),0),32);
	bmap_blit(pgrenade.disp_buf,grenade,vector(0,0,0),vector(0,0,0));
	sprite_move(pgrenade,vector(pos.x,pos.y-20,0));
	layer_sort(pgrenade.panel,30);
	sprite_show(pgrenade);
	pgrenade.mass=10;
 
	var speedx=speed;
	var speedy=speed;
	VECTOR cpos;
	VECTOR force;
	
	while(wait_grenade_p1==1 || wait_grenade_p2==1)
	{
		rotate_gr();
		
		pgrenade.panel.pos_x+=speedx*sin(angle*pi/180);
		pgrenade.panel.pos_y+=speedy*cos(angle*pi/180);

		VECTOR grav;
		vec_set(grav,vector(0,9.81,0));
		
		vec_add(force,grav);
				
		acceleration.x=0;
		acceleration.y=force.y/pgrenade.mass;
		acceleration.z=0;
		
		velocity.x=0;
		velocity.z=0;
		velocity.y=acceleration.y*time_step;
		
		pgrenade.panel.pos_y+=velocity.y*time_step;	
		
		if(pgrenade.panel.pos_x<0 || pgrenade.panel.pos_x>screen_size.x || pgrenade.panel.pos_y<0 || pgrenade.panel.pos_y>screen_size.y)
		{
			//pgrenade=0;
			sys_free(pgrenade);
			wait_grenade_p1=0;
			wait_grenade_p2=0;
			//wait_grenade=0;
			return;
		}
		
		if(pix_collide(pgrenade,terrain,1,10,cpos)==1)
		{
			snd_play(bang,30,0);

			check_players(psprite,cpos);
			pgrenade.panel.pos_x=-100;
			//pgrenade=0;
			sys_free(pgrenade);
			if(psprite==player1)wait_grenade_p1=0;
			if(psprite==player2)wait_grenade_p2=0;
			return;
		}
		wait(1);
	}
	
}

void maggot_enemy()
{
	player2=sprite_create(idle_sheet2,vector(bmap_width(idle_sheet2)/20,bmap_height(idle_sheet2),0),32);
	player2.framesx=20;
	int sizex=bmap_width(idle_sheet2)/player2.framesx;
	sprite_move(player2,vector(800,screen_size.y/2,0));
	layer_sort(player2.panel,99);
	player2.mass=0.5;
	sprite_show(player2);
	
	
	player2anim=sys_malloc(sizeof(anim_seq));
	if(player2anim)
	{
		vec_set(player2anim.frame_start,vector(0,0,0));	
		vec_set(player2anim.frame_end,vector(bmap_width(idle_sheet2)-sizex,0,0));
		vec_set(player2anim.frame_size,vector(sizex,bmap_height(idle_sheet2),0));
		player2anim.wait_delta=4;
	}

	var cur_frame=0;	
	VECTOR pos;

	while(1)
	{
		//pixel under sprite?
		if(!pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf)/2,bmap_height(player2.disp_buf),0),pos))
		{
			player_jump2=1;
			player2.panel.pos_y+=5;
		}
		else
		{
			player_jump2=0;
		}
		
		if(player2_time_left>0 && player2_active && !wait_grenade_p1)
		{
			VECTOR ppos;
			VECTOR mpos;
			VECTOR dir;
			var length=1;
			vec_set(ppos,vector(player2.panel.pos_x+bmap_width(player2.disp_buf)/2,player2.panel.pos_y+bmap_height(player2.disp_buf)/2,0));
			vec_set(mpos,vector(mouse_cursor.x+32/2,mouse_cursor.y+32/2,0));
			var angle=(atan2v(mpos.x-ppos.x,mpos.y-ppos.y)*180/pi);
			dir.x=ppos.x+length*sin(angle*pi/180);
			dir.y=ppos.y+length*cos(angle*pi/180);
		
		   draw_line(vector(ppos.x,ppos.y,0),NULL,100);
		   draw_line(vector(dir.x,dir.y,0),COLOR_RED,100);
		
			if(key_1)throwpower2=1;
			if(key_2)throwpower2=2;
			if(key_3)throwpower2=3;
			if(key_4)throwpower2=4;
			if(key_5)throwpower2=5;
			if(key_6)throwpower2=6;
			if(key_7)throwpower2=7;
			if(key_8)throwpower2=8;
			if(key_9)throwpower2=9;
			if(key_0)throwpower2=10;

			if(key_d)
			{
				player_dir2=wright;
				player_anim_mode2=walk;
				VECTOR pos;
				//collision bottom right?
				if(pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf),bmap_height(player2.disp_buf),0),pos))
				//no collision top middle?
				if(!pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf)/2,0,0),pos))
				//no collision top right
				if(!pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf),0,0),pos))
					//adjust height
					player2.panel.pos_y=pos.y-bmap_height(player2.disp_buf);
				
				//collision right middle?
				if(pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf),bmap_height(player2.disp_buf)/2,0),pos))
				//no collision top middle?
				if(!pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf)/2,0,0),pos))
				//no collision top right
				if(!pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf),0,0),pos))
					//adjust height
					player2.panel.pos_y=pos.y-bmap_height(player2.disp_buf);
				
				//no collision top right?
				if(!pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf),0,0),pos))
				{
					//adjust position
					player2.panel.pos_x+=1;
				}
			}
			
			if(key_a)
			{
				player_dir2=wleft;
				player_anim_mode2=walk;
				VECTOR pos;
				//collision bottom left?
				if(pix_collide_pos(player2,terrain,vector(0,bmap_height(player2.disp_buf),0),pos))
				//no collision top middle?
				if(!pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf)/2,0,0),pos))
				//no collision top left
				if(!pix_collide_pos(player2,terrain,vector(0,0,0),pos))
					//adjust height	
					player2.panel.pos_y=pos.y-bmap_height(player2.disp_buf);
				
				//collision left middle?
				if(pix_collide_pos(player2,terrain,vector(0,bmap_height(player2.disp_buf)/2,0),pos))
				//no collision top middle?
				if(!pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf)/2,0,0),pos))
				//no collision top left
				if(!pix_collide_pos(player2,terrain,vector(0,0,0),pos))
					//adjust height
					player2.panel.pos_y=pos.y-bmap_height(player2.disp_buf);
				
				//no collision top left?
				if(!pix_collide_pos(player2,terrain,vector(0,0,0),pos))
				{
					//adjust position
					player2.panel.pos_x-=1;
				}
			}
			
			if(key_w)
			{
				if(!pix_collide_pos(player2,terrain,vector(bmap_width(player2.disp_buf)/2,-40,0),pos))
				if(player_jump2==0)
				{
					player2.panel.pos_y-=40;
				}
			}
		

			
			if(key_space)
			{
				if(wait_grenade_p2==0 && wait_grenade_p1==0) 
				{
					wait_grenade_p2=1;
					if(mouse_cursor.x<player2.panel.pos_x+bmap_width(player2.disp_buf)/2) player_dir2=wleft;
					else player_dir2=wright;
					launch_gr(player2,dir,angle,throwpower2);
				}
			}
		
					
			if(!key_a && !key_d)
			{
				player_anim_mode2=idle;
				if(player_dir2==wright)
				player2.sprt_sheet=idle_sheet2;
				if(player_dir2==wleft)
				player2.sprt_sheet=idle_sheetl2;				
			}
		}
		
			if(player2_time_left<1)
			{
				player_anim_mode2=idle;
				if(player_dir2==wright)
				player2.sprt_sheet=idle_sheet2;
				if(player_dir2==wleft)
				player2.sprt_sheet=idle_sheetl2;
				
			}

			//handle animation frames
			if(cur_frame<player2.framesx)cur_frame+=1;
			if(cur_frame==player2.framesx) cur_frame=0;
			if(player_anim_mode2==walk && player_dir2==wright)player2.sprt_sheet=walk_sheet2;
			if(player_anim_mode2==walk && player_dir2==wleft)player2.sprt_sheet=walk_sheetl2;
			//if(player_anim_mode2==hit)player2.sprt_sheet=hit_sheet2;
			sprite_anim_frame(player2,player2anim,cur_frame);
	wait(1);
	}	

}

void maggot_player()
{
	player1=sprite_create(idle_sheet,vector(bmap_width(idle_sheet)/20,bmap_height(idle_sheet),0),32);
	player1.framesx=20;
	int sizex=bmap_width(idle_sheet)/player1.framesx;
	sprite_move(player1,vector(300,screen_size.y/2,0));
	layer_sort(player1.panel,99);
	player1.mass=0.5;
	sprite_show(player1);
	
	
	player1anim=sys_malloc(sizeof(anim_seq));
	if(player1anim)
	{
		vec_set(player1anim.frame_start,vector(0,0,0));	
		vec_set(player1anim.frame_end,vector(bmap_width(idle_sheet)-sizex,0,0));
		vec_set(player1anim.frame_size,vector(sizex,bmap_height(idle_sheet),0));
		player1anim.wait_delta=4;
	}

	var cur_frame=0;	
	VECTOR pos;

	while(1)
	{
		//pixel under sprite?
		if(!pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf)/2,bmap_height(player1.disp_buf),0),pos))
		{
			player_jump=1;
			player1.panel.pos_y+=5;
		}
		else
		{
			player_jump=0;
		}
		
		if(player1_time_left>0 && player1_active && !wait_grenade_p2)
		{
			VECTOR ppos;
			VECTOR mpos;
			VECTOR dir;
			var length=1;
			vec_set(ppos,vector(player1.panel.pos_x+bmap_width(player1.disp_buf)/2,player1.panel.pos_y+bmap_height(player1.disp_buf)/2,0));
			vec_set(mpos,vector(mouse_cursor.x+32/2,mouse_cursor.y+32/2,0));
			var angle=(atan2v(mpos.x-ppos.x,mpos.y-ppos.y)*180/pi);
			dir.x=ppos.x+length*sin(angle*pi/180);
			dir.y=ppos.y+length*cos(angle*pi/180);
		
		   draw_line(vector(ppos.x,ppos.y,0),NULL,100);
		   draw_line(vector(dir.x,dir.y,0),COLOR_RED,100);
			
			if(key_1)throwpower1=1;
			if(key_2)throwpower1=2;
			if(key_3)throwpower1=3;
			if(key_4)throwpower1=4;
			if(key_5)throwpower1=5;
			if(key_6)throwpower1=6;
			if(key_7)throwpower1=7;
			if(key_8)throwpower1=8;
			if(key_9)throwpower1=9;
			if(key_0)throwpower1=10;
			
			if(key_d)
			{
				player_dir=wright;
				player_anim_mode=walk;
				VECTOR pos;
				//collision bottom right?
				if(pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf),bmap_height(player1.disp_buf),0),pos))
				//no collision top middle?
				if(!pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf)/2,0,0),pos))
				//no collision top right
				if(!pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf),0,0),pos))
					//adjust height
					player1.panel.pos_y=pos.y-bmap_height(player1.disp_buf);
				
				//collision right middle?
				if(pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf),bmap_height(player1.disp_buf)/2,0),pos))
				//no collision top middle?
				if(!pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf)/2,0,0),pos))
				//no collision top right
				if(!pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf),0,0),pos))
					//adjust height
					player1.panel.pos_y=pos.y-bmap_height(player1.disp_buf);
				
				//no collision top right?
				if(!pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf),0,0),pos))
				{
					//adjust position
					player1.panel.pos_x+=1;
				}
			}
			
			if(key_a)
			{
				player_dir=wleft;
				player_anim_mode=walk;
				VECTOR pos;
				//collision bottom left?
				if(pix_collide_pos(player1,terrain,vector(0,bmap_height(player1.disp_buf),0),pos))
				//no collision top middle?
				if(!pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf)/2,0,0),pos))
				//no collision top left
				if(!pix_collide_pos(player1,terrain,vector(0,0,0),pos))
					//adjust height	
					player1.panel.pos_y=pos.y-bmap_height(player1.disp_buf);
				
				//collision left middle?
				if(pix_collide_pos(player1,terrain,vector(0,bmap_height(player1.disp_buf)/2,0),pos))
				//no collision top middle?
				if(!pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf)/2,0,0),pos))
				//no collision top left
				if(!pix_collide_pos(player1,terrain,vector(0,0,0),pos))
					//adjust height
					player1.panel.pos_y=pos.y-bmap_height(player1.disp_buf);
				
				//no collision top left?
				if(!pix_collide_pos(player1,terrain,vector(0,0,0),pos))
				{
					//adjust position
					player1.panel.pos_x-=1;
				}
			}
			
			if(key_w)
			{
				if(!pix_collide_pos(player1,terrain,vector(bmap_width(player1.disp_buf)/2,-40,0),pos))
				if(player_jump==0)
				{
					player1.panel.pos_y-=40;
				}
			}
			
			if(key_space)
			{
				if(wait_grenade_p1==0 && wait_grenade_p2==0) 
				{
					wait_grenade_p1=1;
					if(mouse_cursor.x<player1.panel.pos_x+bmap_width(player1.disp_buf)/2) player_dir=wleft;
					else player_dir=wright;
					launch_gr(player1,dir,angle,throwpower1);
				}
			}
		
					
			if(!key_a && !key_d)
			{
				player_anim_mode=idle;
				if(player_dir==wright)
				player1.sprt_sheet=idle_sheet;
				if(player_dir==wleft)
				player1.sprt_sheet=idle_sheetl;				
			}
		}		
			if(player1_time_left<1)
			{
				player_anim_mode=idle;
				if(player_dir==wright)
				player1.sprt_sheet=idle_sheet;
				if(player_dir==wleft)
				player1.sprt_sheet=idle_sheetl;
				
			}

			//handle animation frames
			if(cur_frame<player1.framesx)cur_frame+=1;
			if(cur_frame==player1.framesx) cur_frame=0;
			if(player_anim_mode==walk && player_dir==wright)player1.sprt_sheet=walk_sheet;
			if(player_anim_mode==walk && player_dir==wleft)player1.sprt_sheet=walk_sheetl;
			//if(player_anim_mode==hit)player1.sprt_sheet=hit_sheet;
			sprite_anim_frame(player1,player1anim,cur_frame);	
	wait(1);
	}	

}


void zoom_window(sprite* pview,int px,int py)
{
	int px=mouse_cursor.x;
	int py=mouse_cursor.y;
	bmap_fill(pview.disp_buf,vector(0,0,0),100);
	bmap_blitpart(pview.disp_buf,terrain.disp_buf,vector(0,0,0),vector(bmap_width(pview.disp_buf),bmap_height(pview.disp_buf),0),vector(px-100/2+32/2,py-100/2+32/2,0),vector(100,100,0));
}

void the_sun()
{
	BMAP* sunmap="sun.png";
	sprite *sun=sprite_create(sunmap,vector(bmap_width(sunmap),bmap_height(sunmap),0),32);
	bmap_blit(sun.disp_buf,sunmap,vector(0,0,0),vector(0,0,0));
	sprite_move(sun,vector(740,60,1));
	layer_sort(sun.panel,1);
	sprite_show(sun);
	
	BMAP* sunmap1="sun.png";
	sprite *sun1=sprite_create(sunmap1,vector(bmap_width(sunmap1),bmap_height(sunmap1),0),32);
	bmap_blit(sun1.disp_buf,sunmap1,vector(0,0,0),vector(0,0,0));
	sprite_move(sun1,vector(740,60,0));
	layer_sort(sun1.panel,2);
	sprite_show(sun1);
	
	sun.panel.center_x=bmap_width(sunmap)/2;
	sun.panel.center_y=bmap_height(sunmap)/2;
	sun1.panel.center_x=bmap_width(sunmap1)/2;
	sun1.panel.center_y=bmap_height(sunmap1)/2;
	
	while(1)
	{
		sun.panel.angle-=0.5*time_step;
		sun1.panel.angle+=0.5*time_step;
		wait(3);
	}	
}

void the_clouds()
{
	BMAP* cloudmap="cloud.png";
	sprite *cloud=sprite_create(cloudmap,vector(300,300,0),32);
	bmap_blit(cloud.disp_buf,cloudmap,vector(0,0,0),vector(0,0,0));
	sprite_move(cloud,vector(100,50,3));
	layer_sort(cloud.panel,3);
	sprite_show(cloud);
	
	BMAP* cloudmap1="cloud2.png";
	sprite *cloud1=sprite_create(cloudmap1,vector(300,300,0),32);
	bmap_blit(cloud1.disp_buf,cloudmap1,vector(0,0,0),vector(0,0,0));
	sprite_move(cloud1,vector(600,200,3));
	layer_sort(cloud1.panel,3);
	sprite_show(cloud1);

	sprite *cloud2=sprite_create(cloudmap1,vector(300,300,0),32);
	bmap_blit(cloud2.disp_buf,cloudmap1,vector(0,0,0),vector(0,0,0));
	sprite_move(cloud2,vector(-400,150,3));
	layer_sort(cloud2.panel,3);
	sprite_show(cloud2);

	while(1)
	{
		random_seed(0);
		if(cloud.panel.pos_x >screen_size.x)
		{
			sprite_move(cloud,vector(-300,0+random(300),0));
		}
		if(cloud1.panel.pos_x >screen_size.x)
		{
			sprite_move(cloud1,vector(-300,0+random(300),0));
		}
		if(cloud2.panel.pos_x >screen_size.x)
		{
			sprite_move(cloud2,vector(-300,0+random(300),0));
		}
		sprite_move(cloud,vector(cloud.panel.pos_x+0.5*time_step,cloud.panel.pos_y,0));
		sprite_move(cloud1,vector(cloud1.panel.pos_x+0.51*time_step,cloud1.panel.pos_y,0));
		sprite_move(cloud2,vector(cloud2.panel.pos_x+0.51*time_step,cloud2.panel.pos_y,0));
		wait(1);
	}
}

void zoomed_view()
{
	BMAP* pmap=bmap_createblack(300,300,32);
	sprite *zoomed_view=sprite_create(pmap,vector(300,300,0),32);
	sprite_move(zoomed_view,vector(0,0,0));
	layer_sort(zoomed_view.panel,10);
	sprite_show(zoomed_view);
	while(1)
	{
		//zoom_window(zoomed_view,mouse_cursor.x,mouse_cursor.y);
		wait(1);
	}
}

void the_water()
{
	BMAP* watermap="water.png";
	sprite *sprwater=sprite_create(watermap,vector(bmap_width(watermap),bmap_height(watermap),0),32);
	bmap_blit(sprwater.disp_buf,watermap,vector(0,0,0),vector(0,0,0));
	sprite_move(sprwater,vector(0,screen_size.y-bmap_height(watermap)/2,0));
	layer_sort(sprwater.panel,100);
	sprite_show(sprwater);

	BMAP* watermap1="water1.png";
	sprite *sprwater1=sprite_create(watermap1,vector(bmap_width(watermap1),bmap_height(watermap1),0),32);
	bmap_blit(sprwater1.disp_buf,watermap1,vector(0,0,0),vector(0,0,0));
	sprite_move(sprwater1,vector(0,screen_size.y-bmap_height(watermap1)/2,0));
	layer_sort(sprwater1.panel,100);
	sprite_show(sprwater1);

	int dir=0;
	int dir1=0;
	while(1)
	{
		if(sprwater.panel.pos_y>screen_size.y-25)dir=1;
		if(sprwater.panel.pos_y<screen_size.y-bmap_height(watermap)/2)dir=0;
		if(dir==1)sprwater.panel.pos_y-=1.51*time_step;
		if(dir==0)sprwater.panel.pos_y+=1.51*time_step;

		if(sprwater1.panel.pos_y>screen_size.y-25)dir1=1;
		if(sprwater1.panel.pos_y<screen_size.y-bmap_height(watermap1)/2)dir1=0;
		if(dir1==1)sprwater1.panel.pos_y-=2*time_step;
		if(dir1==0)sprwater1.panel.pos_y+=2*time_step;

		wait(1);
	}
}


void the_terrain(int cave_mode)
{
	BMAP* terrainbmp=create_terr("noise.png",integer(random(10)),"terrain.png","grass.png",10,cave_mode);
	
	terrain=sprite_create(terrainbmp,vector(bmap_width(terrainbmp),bmap_height(terrainbmp),0),32);
	bmap_blit(terrain.disp_buf,terrainbmp,vector(0,0,0),vector(0,0,0));
	
	sprite_move(terrain,vector(0,0,0));
	layer_sort(terrain.panel,3);
	sprite_show(terrain);

	if(cave_mode==0)
	{
		the_clouds();
		the_sun();
		BMAP* backmap="background1.png";
		sprite *background=sprite_create(backmap,vector(1280,800,0),32);
		bmap_blit(background.disp_buf,backmap,vector(0,0,0),vector(0,0,0));
		sprite_move(background,vector(0,0,0));
		layer_sort(background.panel,-1);
		sprite_show(background);
	}
	if(cave_mode==1)
	{
		BMAP* backmap="background2.png";
		sprite *background=sprite_create(backmap,vector(1280,800,0),32);
		bmap_blit(background.disp_buf,backmap,vector(0,0,0),vector(0,0,0));
		sprite_move(background,vector(0,0,0));
		layer_sort(background.panel,-1);
		sprite_show(background);
	}
}


void the_timer()
{
	PANEL* time_panel = pan_create(NULL,0);
	FONT* my_font = font_create("Arial#40");
	int time_elmnt_time=pan_setdigits(time_panel,0,screen_size.x/2,screen_size.y-50,"%2.f",my_font,1,player1_time_left);
	int time_elmnt_name=pan_setstring(time_panel,0,screen_size.x/2,screen_size.y-100,my_font,str_create("player 1 time left"));
	vec_set(time_panel.blue,vector(0,255,255));
	layer_sort(time_panel,101);
	set(time_panel,SHOW);
 
	PANEL* p2_time_up = pan_create(NULL,0);
	FONT* my_font1 = font_create("Arial#240");
	pan_setstring(p2_time_up,0,screen_size.x/2,screen_size.y/2,my_font,str_create("PLAYER 2 times up!"));
	vec_set(p2_time_up.blue,vector(255,0,0));
	layer_sort(p2_time_up,101);
	
	PANEL* p1_time_up = pan_create(NULL,0);
	pan_setstring(p1_time_up,0,screen_size.x/2,screen_size.y/2,my_font,str_create("PLAYER 1 times up!"));
	vec_set(p1_time_up.blue,vector(0,0,255));
	layer_sort(p1_time_up,101);
	
	while(1)
	{
		if(player1.panel.pos_x<1)player1.panel.pos_x=1;
		if(player1.panel.pos_x+bmap_width(player1.disp_buf)>screen_size.x-1)player1.panel.pos_x=screen_size.x-bmap_width(player1.disp_buf)-1;
		if(player1.panel.pos_y>screen_size.y)
		{
			PANEL* player1_lose_panel = pan_create(NULL,0);
			FONT* my_font = font_create("Arial#100");
			pan_setstring(player1_lose_panel,0,screen_size.x/2,screen_size.y/2,my_font,str_create("player1 loses!!"));
			layer_sort(player1_lose_panel,101);
			set(player1_lose_panel,SHOW);
			wait(-4);
			sys_exit("try again!");
		}
		
		if(player2.panel.pos_x<1)player2.panel.pos_x=1;
		if(player2.panel.pos_x+bmap_width(player2.disp_buf)>screen_size.x-1)player2.panel.pos_x=screen_size.x-bmap_width(player2.disp_buf)-1;
		if(player2.panel.pos_y>screen_size.y)
		{
			PANEL* player2_lose_panel = pan_create(NULL,0);
			FONT* my_font = font_create("Arial#100");
			pan_setstring(player2_lose_panel,0,screen_size.x/2,screen_size.y/2,my_font,str_create("player2 loses!!"));
			layer_sort(player2_lose_panel,101);
			set(player2_lose_panel,SHOW);
			wait(-4);
			sys_exit("try again!");
		}
		
		if(player1_time_left>0)
		{
			player1_time_left-=0.3*time_step;
			pan_setdigits(time_panel,time_elmnt_time,screen_size.x/2,screen_size.y-50,"%2.f",my_font,1,player1_time_left);
			pan_setstring(time_panel,time_elmnt_name,screen_size.x/2,screen_size.y-100,my_font,str_create("player 1 time left"));
 		}
		if(player2_time_left>0)
		{
			player2_time_left-=0.3*time_step;
 			pan_setdigits(time_panel,time_elmnt_time,screen_size.x/2,screen_size.y-50,"%2.f",my_font,1,player2_time_left);
 			pan_setstring(time_panel,time_elmnt_name,screen_size.x/2,screen_size.y-100,my_font,str_create("player 2 time left"));
 		}
			
		if(player1_time_left<1)
		{
			if(wait_grenade_p1==0 && player1_active==1)
			{
				player1_time_left=0;
				set(p1_time_up,SHOW);
				wait(-1);
				sprite_move(explode,vector(-300,0,0));
				reset(p1_time_up,SHOW);
				player1_active=0;
				player2_active=1;
				player2_time_left=60;
				//wait_grenade_p2=0;
			}
		}
		
		if(player2_time_left<1)
		{
			if(wait_grenade_p2==0 && player2_active==1)
			{
				player2_time_left=0;
				set(p2_time_up,SHOW);
				wait(-1);
				sprite_move(explode,vector(-300,0,0));
				reset(p2_time_up,SHOW);
				player2_active=0;
				player1_active=1;
				player1_time_left=60;
				//wait_grenade_p1=0;
			}
		}
		
		draw_text("p1",player1.panel.pos_x,player1.panel.pos_y-20,COLOR_RED);
		draw_text("p2",player2.panel.pos_x,player2.panel.pos_y-20,COLOR_BLUE);
				
		if(key_esc)
		{
			sys_exit("bye");
		}
		wait(1);
	}
}

void main()
{
	d3d_triplebuffer = 1;
	video_set(1280,800,32,1);
	fps_max=60;
	
	BMAP* mousemap="mouse.tga";
	mouse_map=mousemap;
	mouse_mode=4;
	random_seed(0);
	the_terrain(integer(random(2)));
 
	//pixel collision test buffer
	pix_buf=bmap_createblack(screen_size.x,screen_size.y,32);

	//remove chunks of terrain
	explodexor=sprite_create(explodexormap,vector(bmap_width(explodexormap),bmap_height(explodexormap),0),32);
	bmap_blit(explodexor.disp_buf,explodexormap,vector(0,0,0),vector(0,0,0));
	
	random_seed(0);
	int xx=40;
	int i;
	for(i=0;i<4;i++)
	{
		sprite_move(explodexor,vector(integer(random(screen_size.x))-bmap_width(explodexormap),screen_size.y-integer(random(20))-bmap_height(explodexormap),0));
		remove_pixels_with(explodexor,terrain);
		if(i==1)bmap_blit(explodexor.disp_buf,explodexormap1,vector(0,0,0),vector(0,0,0));
		if(i==2)bmap_blit(explodexor.disp_buf,explodexormap2,vector(0,0,0),vector(0,0,0));
	}	

	the_water();
	
	BMAP* startmap="start.png";
	sprite *start=sprite_create(startmap,vector(bmap_width(startmap),bmap_height(startmap),0),32);
	bmap_blit(start.disp_buf,startmap,vector(0,0,0),vector(0,0,0));
	sprite_move(start,vector(0,200,0));
	layer_sort(start.panel,99);
	sprite_show(start);
	int dir=0;

	music_handle=snd_loop(happy_land,15,0);
	while(!key_enter)
	{
		draw_text("W      - jump",0,10,COLOR_BLUE);
		draw_text("A      - move left",0,30,COLOR_BLUE);
		draw_text("D      - move right",0,50,COLOR_BLUE);
		draw_text("1 to 0 - adjust trow power",0,70,COLOR_BLUE);
		draw_text("Space  - throw",0,90,COLOR_RED);
		draw_text("Mouse  - set aim direction",0,110,COLOR_BLUE);
		draw_text("Maggots by Wjbender ,gamestudio a8 free",0,130,COLOR_RED);

		if(start.panel.angle>40)dir=1;
		if(start.panel.angle<-40)dir=0;
		if(dir==0)
			start.panel.angle+=1*time_step;
		else
			start.panel.angle-=1*time_step;
		wait(1);
	}
	reset(start.panel,SHOW);

	//zoomed_view();
	water_handle=snd_loop(water,2,0);
	wind_handle=snd_loop(wind,25,0);
	hawk_handle=snd_play(hawk,15,0);
		
	//sprite 1
	maggot_enemy();
	maggot_player();
	the_timer();

	PANEL* p1_info = pan_create(NULL,0);
	FONT* my_font = font_create("Arial#40");
	pan_setstring(p1_info,0,0,200,my_font,str_create("health"));
	pan_setdigits(p1_info,0,0,240,"%2.f",my_font,1,player1_health);
	pan_setstring(p1_info,0,0,280,my_font,str_create("power"));
	pan_setdigits(p1_info,0,0,320,"%2.f",my_font,1,throwpower1);
	vec_set(p1_info.blue,vector(0,0,255));
	layer_sort(p1_info,101);
	set(p1_info,SHOW);
	
	PANEL* p2_info = pan_create(NULL,0);
	pan_setstring(p2_info,0,screen_size.x-190,200,my_font,str_create("health"));
	pan_setdigits(p2_info,0,screen_size.x-190,240,"%2.f",my_font,1,player2_health);
	pan_setstring(p2_info,0,screen_size.x-190,280,my_font,str_create("power"));
	pan_setdigits(p2_info,0,screen_size.x-190,320,"%2.f",my_font,1,throwpower2);
	vec_set(p2_info.blue,vector(255,0,0));
	layer_sort(p2_info,101);
	set(p2_info,SHOW);

	explode=sprite_create(explodemap,vector(bmap_width(explodemap),bmap_height(explodemap),0),32);
	bmap_blit(explode.disp_buf,explodemap,vector(0,0,0),vector(0,0,0));
	sprite_move(explode,vector(-300,0,0));
	layer_sort(explode.panel,99);
	sprite_show(explode);

}